Index: src/treeviews.c
===================================================================
--- src/treeviews.c	(Revision 3589)
+++ src/treeviews.c	(Arbeitskopie)
@@ -193,7 +193,7 @@ void treeviews_update_tag_list(GeanyDocu
 		if (doc->priv->tag_tree == NULL)
 		{
 			doc->priv->tag_store = gtk_tree_store_new(
-				SYMBOLS_N_COLUMNS, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_STRING);
+				SYMBOLS_N_COLUMNS, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_STRING, G_TYPE_INT);
 			doc->priv->tag_tree = gtk_tree_view_new();
 			prepare_taglist(doc->priv->tag_tree, doc->priv->tag_store);
 			gtk_widget_show(doc->priv->tag_tree);
@@ -677,14 +677,19 @@ static gboolean on_taglist_tree_selectio
 	{
 		const TMTag *tag;

-		gtk_tree_model_get(model, &iter, SYMBOLS_COLUMN_TAG, &tag, -1);
-		if (!tag)
-			return FALSE;
+		gtk_tree_model_get(model, &iter, SYMBOLS_COLUMN_TAG, &tag, SYMBOLS_COLUMN_LINE, &line, -1);
+
+		if (tag->atts.entry.line != line)
+			g_warning("tag.line: %d, line: %d", tag->atts.entry.line, line);
+
+		g_return_val_if_fail(line > 0, FALSE);

-		line = tag->atts.entry.line;
-		if (line > 0)
 		{
 			GeanyDocument *doc = document_get_current();
+			GtkWidget *tree = GTK_WIDGET(gtk_tree_selection_get_tree_view(selection));
+
+			if (doc->priv->tag_tree != tree)
+				g_warning("doc-tree != current-tree");

 			navqueue_goto_line(doc, doc, line);
 		}
Index: src/treeviews.h
===================================================================
--- src/treeviews.h	(Revision 3589)
+++ src/treeviews.h	(Arbeitskopie)
@@ -43,6 +43,7 @@ enum
 	SYMBOLS_COLUMN_NAME,
 	SYMBOLS_COLUMN_TAG,
 	SYMBOLS_COLUMN_TOOLTIP,
+	SYMBOLS_COLUMN_LINE,
 	SYMBOLS_N_COLUMNS
 };

Index: src/symbols.c
===================================================================
--- src/symbols.c	(Revision 3591)
+++ src/symbols.c	(Arbeitskopie)
@@ -1050,6 +1050,7 @@ static void add_tree_tag(GeanyDocument *
 			SYMBOLS_COLUMN_ICON, icon,
 			SYMBOLS_COLUMN_NAME, name,
 			SYMBOLS_COLUMN_TAG, tag,
+			SYMBOLS_COLUMN_LINE, tag->atts.entry.line,
 			-1);

 		if (gtk_check_version(2, 12, 0) == NULL)
